# Template Strings

In this section you'll find the schema of the keys available when interpolating template strings, as well as a list of all available helper functions. See our [Variables and Templating](/features/variables-and-templating.md) guide for more information and usage examples.

Note that there are multiple sections, since different configuration types and fields have different templating keys available to them. Please make sure to refer to the correct section.

* [Helper Functions](/reference/template-strings/functions.md) — All available helper functions in template strings.
* [Projects](/reference/template-strings/projects.md) — Keys available to every field in Project configurations.
* [Environments](/reference/template-strings/environments.md) — Keys available in the `environments` field in Project configurations.
* [Providers](/reference/template-strings/providers.md) — Keys available in the `providers` field in Project configurations.
* [Action (all fields)](/reference/template-strings/action-all-fields.md) — Keys available for built-in fields on action configs.
* [Action specs](/reference/template-strings/action-specs.md) — Keys available for the `spec` field on action configs.
* [Modules](/reference/template-strings/modules.md) — Keys available for Module configurations.
* [Remote Sources](/reference/template-strings/remote-sources.md) — Keys available in the `sources` field in Project configurations.
* [Project Outputs](/reference/template-strings/project-outputs.md) — Keys available in the `sources` field in Project configurations.
* [Custom Commands](/reference/template-strings/custom-commands.md) — Keys available in `exec` and `gardenCommand` fields in custom Command configs.
* [Workflows](/reference/template-strings/workflows.md) — Keys available in Workflow configurations.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.garden.io/reference/template-strings.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
